package fr.nitorac.aurionweb.aurionweb;

import android.content.Context;
import android.os.AsyncTask;

import com.afollestad.materialdialogs.LayoutMode;
import com.afollestad.materialdialogs.MaterialDialog;
import com.afollestad.materialdialogs.bottomsheets.BottomSheet;
import com.afollestad.materialdialogs.customview.DialogCustomViewExtKt;

import java.security.GeneralSecurityException;

import fr.nitorac.aurionweb.R;

public class CheckConnectionTask extends AsyncTask<AurionCred, Void, Boolean> {

    private MaterialDialog loading;
    private ConnectionCheck callback;
    private AurionSession session;

    public CheckConnectionTask(Context c, ConnectionCheck callback){
        this(c, new AurionSession(), callback);
    }

    public CheckConnectionTask(Context c, AurionSession session, ConnectionCheck callback){
        this.callback = callback;
        this.session = session;
        loading = new MaterialDialog(c, new BottomSheet(LayoutMode.WRAP_CONTENT))
            .cancelable(false)
            .cancelOnTouchOutside(false)
            .title(R.string.loading, null)
            .noAutoDismiss();
        DialogCustomViewExtKt.customView(loading, R.layout.dialog_loading, null, false, false, true, true);
        loading.dismiss();
    }

    @Override
    protected void onPreExecute() {
        super.onPreExecute();
        loading.show();
    }

    @Override
    protected void onPostExecute(Boolean res) {
        super.onPostExecute(res);
        loading.dismiss();
        callback.onResult(res);
    }

    @Override
    protected Boolean doInBackground(AurionCred... cred) {
        try {
            return AurionManager.getInstance().checkPassword(session, cred[0]);
        } catch (GeneralSecurityException e) {
            e.printStackTrace();
            return false;
        }
    }

    public interface ConnectionCheck {
        void onResult(Boolean res);
    }
}
