package fr.nitorac.aurionweb.fragments;

import androidx.fragment.app.Fragment;

import fr.nitorac.aurionweb.aurionweb.AurionManager;
import fr.nitorac.aurionweb.aurionweb.AurionSession;
import fr.nitorac.aurionweb.aurionweb.CheckConnectionTask;
import fr.nitorac.aurionweb.security.SecurityManager;

public abstract class AurionViewFragment extends Fragment {

    private AurionSession currentSession = new AurionSession();

    public abstract String getName();

    public abstract void preload();

    @Override
    public void onResume() {
        super.onResume();
        CheckConnectionTask check = new CheckConnectionTask(getContext(), currentSession, res -> {
            if(res){
                preload();
            }else{
                AurionManager.getInstance().spawnLoginDialog(getContext());
            }
        });
        check.execute(SecurityManager.creds);
    }
}
